//Forwarding Unit
//Kamyar Rafati & Naeem Esfahani

module Forward_Unit (EX_Rt, EX_Rs, EX_Rd,  ID_Rt, ID_Rs, MEM_Rd, WB_Rd, 
					 MEM_RegWrite, WB_RegWrite, EX_RegWrite, EX_ForwardMuxA, 
					 EX_ForwardMuxB, ID_ForwardEqualA, ID_ForwardEqualB, EX_MemRead);
	
	input[4:0]	EX_Rt, EX_Rs, EX_Rd,  ID_Rt, ID_Rs, MEM_Rd, WB_Rd;
	input		MEM_RegWrite, WB_RegWrite, EX_RegWrite, EX_MemRead;
	output[1:0]	EX_ForwardMuxA, EX_ForwardMuxB, ID_ForwardEqualA, ID_ForwardEqualB;
	reg[1:0]	EX_ForwardMuxA, EX_ForwardMuxB, ID_ForwardEqualA, ID_ForwardEqualB;
	
	//if we want to have branch after lw we must add extra logic to both this part and data-path
	always @(EX_Rt or EX_Rs or EX_Rd or  ID_Rt or ID_Rs or MEM_Rd or WB_Rd or MEM_RegWrite 
         or WB_RegWrite or EX_RegWrite)
	begin 
	// Branch Check
		//EX_Hazard
		if(MEM_RegWrite && MEM_Rd != 0 && EX_Rd != ID_Rs && MEM_Rd == ID_Rs)
			ID_ForwardEqualA = 1;
		//ID Hazard
		else if(EX_RegWrite && EX_Rd != 0 && EX_Rd == ID_Rs)
			ID_ForwardEqualA = 2;
		else ID_ForwardEqualA = 0;

		//EX Hazard
		if(MEM_RegWrite && MEM_Rd != 0 && EX_Rd != ID_Rt && MEM_Rd == ID_Rt)
			ID_ForwardEqualB = 1;
		//ID Hazard	
		else if(EX_RegWrite && EX_Rd != 0 && EX_Rd == ID_Rt)
			ID_ForwardEqualB = 2;
		else ID_ForwardEqualB = 0;

	// ALU Check
		// Mem hazard
		if(WB_RegWrite && WB_Rd != 0 && MEM_Rd !=EX_Rs && WB_Rd == EX_Rs)
			EX_ForwardMuxA = 1;
		//EX hazard
		else if(MEM_RegWrite && MEM_Rd != 0 && MEM_Rd == EX_Rs)
			EX_ForwardMuxA = 2;
		else EX_ForwardMuxA = 0;

		// Mem HAzard
		if(WB_RegWrite && WB_Rd != 0 && MEM_Rd !=EX_Rt && WB_Rd == EX_Rt)	
		//if(WB_RegWrite && WB_Rd != 0 && (MEM_Rd !=EX_Rt && EX_MemRead != 0) && WB_Rd == EX_Rt)
		//if(WB_RegWrite && WB_Rd != 0 && WB_Rd == EX_Rt)
			EX_ForwardMuxB = 1;

		//EX Hazard	
		else if(MEM_RegWrite && MEM_Rd != 0 && MEM_Rd == EX_Rt)
			EX_ForwardMuxB = 2;
		else EX_ForwardMuxB = 0;
	end	
endmodule
